/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2015 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2015 Ryu Takegami (Twitter:@RyuTakegami)
 *
 *	[ DMAC(HD68B44) AV40dlΉ ]
 */

#ifndef _dmac_h_
#define _dmac_h_

#if XM7_VER >= 3

#ifdef __cplusplus
extern "C" {
#endif
/*
 *	vGg
 */
BOOL FASTCALL dmac_init(void);
										/*  */
void FASTCALL dmac_cleanup(void);
										/* N[Abv */
void FASTCALL dmac_reset(void);
										/* Zbg */
void FASTCALL dmac_start(void);
										/* X^[g */
void FASTCALL dmac_exec(void);
										/* PXebv] */
BOOL FASTCALL dmac_readb(WORD addr, BYTE *dat);
										/* ǂݏo */
BOOL FASTCALL dmac_writeb(WORD addr, BYTE dat);
										/*  */
BOOL FASTCALL dmac_save(int fileh);
										/* Z[u */
BOOL FASTCALL dmac_load(int fileh, int ver);
										/* [h */

/*
 *	O[o [N
 */
extern WORD dma_adr[4];
										/* AhXWX^ */
extern WORD dma_bcr[4];
										/* ]ꐔWX^ */
extern BYTE dma_chcr[4];
										/* `l䃌WX^ */
extern BYTE dma_dcr;
										/* f[^`FC䃌WX^ */
extern BYTE dma_pcr;
										/* D搧䃌WX^ */
extern BYTE dma_icr;
										/* 荞ݐ䃌WX^ */
extern BYTE dmac_reg;
										/* ݑIĂ郌WX^ԍ */
extern BYTE dma_comp;
										/* DMA]tO */
extern BOOL dma_flag;
										/* DMAtO */
extern BOOL dma_burst_transfer;
										/* DMAo[Xg]tO */
#ifdef __cplusplus
}
#endif

#endif	/* XM7_VER >= 3 */
#endif	/* _dmac_h_ */
