/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2015 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2015 Ryu Takegami (Twitter:@RyuTakegami)
 *
 *	[ Win32API ]
 */

#ifdef _WIN32

#ifndef _w32_h_
#define _w32_h_

#ifndef __STDLIB_H
#include <stdlib.h>
#endif

/*
 *	萔A^`
 */
#ifndef WM_THEMECHANGED
#define WM_THEMECHANGED		0x031A		/* WindowsXP e[}KpbZ[W */
#endif
#ifndef	WM_MOUSEWHEEL
#define	WM_MOUSEWHEEL		0x020a		/* VS2005p(_WIN32_WINDOWS̑) */
#endif

#ifdef __cplusplus
extern "C" {
#endif
/*
 *	vGg
 */
HFONT FASTCALL CreateTextFont(void);
										/* eLXgtHg쐬 */
void FASTCALL LockVM(void);
										/* VMbN */
void FASTCALL UnlockVM(void);
										/* VMAbN */
void FASTCALL OnSize(HWND hWnd, WORD cx, WORD cy);
										/* TCYύX */
void FASTCALL OnCommand(HWND hWnd, WORD wID);
										/* WM_COMMAND */
void FASTCALL OnMenuPopup(HWND hWnd, HMENU hMenu, UINT uPos);
										/* WM_INITMENUPOPUP */
void FASTCALL OnDropFiles(HANDLE hDrop);
										/* WM_DROPFILES */
void FASTCALL OnCmdLine(LPSTR lpCmdLine);
										/* R}hC */
void FASTCALL OnAbout(HWND hWnd);
										/* o[W */
void FASTCALL OnRefresh(HWND hWnd);
										/* ŐV̏ɍXV(R) */
void FASTCALL EnableMenuSub(HMENU hMenu, UINT uID, BOOL bEnable);
										/* j[Enable */
void FASTCALL CheckMenuSub(HMENU hMenu, UINT uID, BOOL bCheck);
										/* j[Check */
void FASTCALL InitIMEDLL(void);
										/* IMEL/API DLL */
void FASTCALL CleanIMEDLL(void);
										/* IMEL/API DLLN[Abv */
BOOL FASTCALL EnableIME(HWND hWnd, BOOL flag);
										/* IMEL/؂芷 */
#ifdef MOUSE
void FASTCALL MouseModeChange(BOOL flag);
										/* }EXLv`؂ւ */
#endif

/*
 *	v[N
 */
#if XM7_VER == 1 && defined(BUBBLE)
extern char InitialDir[6][_MAX_DRIVE + _MAX_PATH];
										/* fBNg */
#else
extern char InitialDir[5][_MAX_DRIVE + _MAX_PATH];
										/* fBNg */
#endif
extern HINSTANCE hAppInstance;
										/* AvP[V CX^X */
extern HINSTANCE hResInstance;
										/* \[X CX^X */
extern HWND hMainWnd;
										/* CEChE */
extern HWND hDrawWnd;
										/* `EChE */
extern int nErrorCode;
										/* G[R[h */
extern BOOL bMenuLoop;
										/* j[[v */
extern BOOL bMenuExit;
										/* j[otO */
extern BOOL bCloseReq;
										/* IvtO */
extern LONG lCharWidth;
										/* LN^ */
extern LONG lCharHeight;
										/* LN^c */
extern BOOL bSync;
										/* sɓ */
extern BOOL bSyncDisasm[3];
										/* tAZuPCɓ */
extern BOOL bMinimize;
										/* ŏtO */
extern BOOL bActivate;
										/* ANeBx[gtO */
extern BOOL bHideStatus;
										/* Xe[^Xo[B */
extern HICON hAppIcon;
										/* ACRnh */
extern int nAppIcon;
										/* ACRԍ(1`3) */
extern BOOL bNTflag;
										/* OS^Cv1(NT) */
extern BOOL bXPflag;
										/* OS^Cv2(XP) */
extern BOOL bVistaflag;
										/* OS^Cv3(Vista) */
extern BOOL bWin7flag;
										/* OS^Cv4(Windows 7) */
extern BOOL bWin8flag;
										/* OS^Cv4(Windows 8) */
extern BOOL bWin10flag;
										/* OS^Cv3(Vista/7) */
extern BOOL bMMXflag;
										/* MMXΉtO */
extern BOOL bCMOVflag;
										/* CMOVΉtO */
extern BOOL bHighPriority;
										/* nCvCIeBtO */
extern POINT WinPos;
										/* EBhEʒu */
extern BOOL bOFNCentering;
										/* t@C_CAÕZ^O */
#ifdef ROMEO
extern BOOL bRomeo;
										/* ROMEOFtO */
#endif
#if ((XM7_VER <= 2) && defined(FMTV151))
extern BOOL bFMTV151;
										/* `lR[G~[V */
#endif
extern HFONT hFont;
										/* TuEBhEptHgnh */
#if XM7_VER >= 3
extern BOOL bGravestone;
										/* !? */
#endif
#ifdef __cplusplus
}
#endif

#endif	/* _w32_h_ */
#endif	/* _WIN32 */
