/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2015 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2015 Ryu Takegami (Twitter:@RyuTakegami)
 *
 *	[ vO}u^C}(MB8873H) ]
 */

#ifndef _ptm_h_
#define _ptm_h_

#ifdef __cplusplus
extern "C" {
#endif
/*
 *	vGg
 */
BOOL FASTCALL ptm_init(void);
										/*  */
void FASTCALL ptm_cleanup(void);
										/* N[Abv */
void FASTCALL ptm_reset(void);
										/* Zbg */
BOOL FASTCALL ptm_readb(WORD addr, BYTE *dat);
										/* ǂݏo */
BOOL FASTCALL ptm_writeb(WORD addr, BYTE dat);
										/*  */
BOOL FASTCALL ptm_save(int fileh);
										/* Z[u */
BOOL FASTCALL ptm_load(int fileh, int ver);
										/* [h */

/*
 *	O[o [N
 */
extern int ptm_counter[6];	
										/* JE^ */
extern int ptm_counter_preset[6];
										/* JE^vZbgl */

extern BYTE ptm_mode_select[3];
										/* 샂[h */
extern BOOL ptm_running_flag[3];
										/* 쒆tO */

extern BOOL ptm_out_flag[3];
										/* o͋tO */
extern BOOL ptm_irq_flag_int[3];
										/* 荞݃tO */
extern BOOL ptm_irq_mask_int[3];
										/* 荞݃}XNtO */
extern BOOL ptm_mode_16bit[3];
										/* 16rbgJEg[h */
extern BOOL ptm_clock_type[3];
										/* NbN */

extern BOOL ptm_preset_mode;
										/* vZbg(InternalReset)[h */
extern BOOL ptm_select_reg1;
										/* WX^I */
extern BOOL ptm_clock_divide;
										/* NbN[h */
#ifdef __cplusplus
}
#endif

#endif	/* _ptm_h_ */
