/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2015 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2015 Ryu Takegami (Twitter:@RyuTakegami)
 *
 *	[ ⏕c[ ]
 */

#ifndef _tools_h_
#define _tools_h_

#ifdef __cplusplus
extern "C" {
#endif
/*
 *	vGg
 */
BOOL FASTCALL make_new_d77(char *fname, char *name, BOOL mode2dd);
										/* uNfBXN쐬 */
BOOL FASTCALL make_new_userdisk(char *fname, char *name, BOOL mode2dd);
										/* [UfBXN쐬 */
BOOL FASTCALL make_new_t77(char *fname);
										/* uNe[v쐬 */
#if XM7_VER == 1 && defined(BUBBLE)
BOOL FASTCALL make_new_bubble(char *fname, char *name);
										/* uNouJZbg쐬 */
#endif
BOOL FASTCALL conv_vfd_to_d77(char *src, char *dst, char *name);
										/* VFDD77ϊ */
BOOL FASTCALL conv_2d_to_d77(char *src, char *dst, char *name);
										/* 2D/2DDD77ϊ */
BOOL FASTCALL conv_vtp_to_t77(char *src, char *dst);
										/* VTPT77ϊ */
BOOL FASTCALL capture_to_bmp(char *fname, BOOL fullscan, BOOL mode);
										/* ʃLv`(BMP) */
BOOL FASTCALL capture_to_bmp2(char *fname, BOOL mode);
										/* ʃLv`(BMPEk摜) */
void FASTCALL mix_color_init(double gamma);
										/* 摜kJ[e[u */
WORD FASTCALL mix_color(BYTE *palet_table, BYTE palet_count, BOOL mode);
										/* 摜kJ[ */
#if XM7_VER == 1 && defined(BUBBLE)
BOOL FASTCALL conv_bbl_to_b77(char *src, char *dst, char *name);
										/* BBLB77ϊ */
#endif
#ifdef __cplusplus
}
#endif

#endif	/* _tools_h_ */
