/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2015 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2015 Ryu Takegami (Twitter:@RyuTakegami)
 *
 *	[ Win32API \ ]
 */

#ifdef _WIN32

#ifndef _w32_draw_h_
#define _w32_draw_h_

/*
 *	萔`(V2p)
 */
#define	V2XPoint	464
#define	V2YPoint	10
#define	V2XSize		27
#define	V2YSize		14
#define	V2XPxSz		5
#define	V2YPxSz		2

#ifdef _w32_h_

#ifdef __cplusplus
extern "C" {
#endif
/*
 *	vGg
 */
void FASTCALL InitDraw(void);
										/*  */
void FASTCALL CleanDraw(void);
										/* N[Abv */
BOOL FASTCALL SelectDraw(HWND hWnd);
										/* ZNg */
void FASTCALL ModeDraw(HWND hWnd, BOOL bFullScreen);
										/* `惂[hύX */
void FASTCALL OnPaint(HWND hWnd);
										/* ĕ` */
void FASTCALL OnDraw(HWND hWnd, HDC hDC);
										/* ` */
void FASTCALL EnterMenu(HWND hWnd);
										/* j[Jn */
void FASTCALL ExitMenu(void);
										/* j[I */
void FASTCALL SetDirtyFlag(int top, int bottom, BOOL flag);
										/* ĕ`惉X^ꊇݒ */
#endif	/* _w32_h_ */


/*
 *	v[N
 */
extern BOOL bFullScreen;
										/* tXN[ */
extern BOOL bFullRequested;
										/* tXN[v */
extern BOOL bDrawSelected;
										/* ZNgς݃tO */
extern BOOL bFullScan;
										/* tXL(Window) */
extern BOOL bFullScanFS;
										/* tXL(FullScreen) */
extern BOOL bDoubleSize;
										/* 2{\tO */
#if XM7_VER == 1
extern BOOL bGreenMonitor;
										/* O[j^tO */
#endif
#if XM7_VER == 2
extern BOOL bTTLMonitor;
										/* TTLj^tO */
#endif
extern BOOL bRasterRendering;
										/* X^_OtO */
#if ((XM7_VER <= 2) && defined(FMTV151))
extern const BYTE nV2data[];
										/* V2f[^ */
#endif
#ifdef __cplusplus
}
#endif

#endif	/* _w32_draw_h_ */
#endif	/* _WIN32 */
