/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2015 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2015 Ryu Takegami (Twitter:@RyuTakegami)
 *	line printer support 2010-2013 by Ben.JP
 *
 *	[ Win32API ʎq` ]
 */

#ifdef _WIN32

/* j[AANZ[^A^C}[ */
#define IDR_MAINMENU					101
#define IDR_ACCELERATOR 				102
#define IDR_TIMER						103

/* ACRA_CAO */
#if XM7_VER != 2
#define IDI_APPICON						104
#else
#define IDI_AVICON						104
#endif
#define IDD_ABOUTDLG					105
#define IDI_WNDICON						106
#define IDR_DISASMMENU					107
#define IDD_ADDRDLG						108
#define IDR_BREAKPOINTMENU				109
#define IDD_TITLEDLG					110
#define IDD_GENERALPAGE					111
#define IDD_SOUNDPAGE					112
#define IDD_KBDPAGE						113
#define IDD_KEYINDLG					114
#define IDD_JOYPAGE						115
#define IDI_FUJICON						116
#define IDD_SCRPAGE						117
#define IDD_OPTPAGE						118
#define IDI_2DDICON						119
#if XM7_VER != 2
#define IDI_AVICON						120
#endif
#define IDI_TAMORIICON					121
#define IDI_FUJICON2					122
#define IDD_TITLEDLG_2D					123
#define IDI_SXICON						124
#define IDI_D77ICON						125
#define IDI_2DICON						126
#define IDI_VFDICON						127
#define IDI_VERICON						128
#define IDD_BREAKPDLG					130
#define IDR_MEMDMPMENU					131
#define IDD_MEMDLG						132
#define IDD_REGDLG						133
#define IDR_CPUREGMENU					134
#define IDD_SEARCHDLG					135
#define IDD_SOUNDPAGE2					136
#define IDD_PORTPAGE					137
#define IDD_VOLUMEPAGE					138
#define IDD_MEDIATYPEDLG				139
#define IDD_LPRPAGE						140
#define IDD_ALTERPAGE					141

/* ACR (by tenmaru) */
#define	IDI_FM8ICON						150
#define	IDI_FM7ICON						151
#define	IDI_FM77ICON					152
#define	IDI_77AVICON					153
#define	IDI_40EXICON					154
#define	IDI_40SXICON					155
#define	IDI_40EXICON2					156
#define	IDI_FM11ICON					157	/* reserved... */
#define	IDI_FDICON_1					160
#define	IDI_FDICON_1_2D					161
#define	IDI_FDICON_1_D77				162
#define	IDI_FDICON_1_VFD				163
#define	IDI_FDICON_2					164
#define	IDI_FDICON_2_2D					165
#define	IDI_FDICON_2_2DD				166
#define	IDI_FDICON_2_D77				167
#define	IDI_FDICON_2_VFD				168
#define	IDI_FDICON_3					169
#define	IDI_FDICON_3_2D					170
#define	IDI_FDICON_3_2DD				171
#define	IDI_FDICON_3_D77				172
#define	IDI_FDICON_3_VFD				173
#define	IDI_TAPEICON					174
#define	IDI_TAPEICON_T77				175

/* `ChEChE */
#define ID_TOOL_BAR						1000
#define ID_STATUS_BAR					1001
#define ID_CAPTURE_WINDOW				1002

/* o[W_CAO */
#define IDC_TITLE						1010
#define IDC_COPYRIGHT					1011
#define IDC_ABOUTICON					1012
#define IDC_FMCOPY						1013
#define IDC_VERSION						1014
#define IDC_URL_OLD						1015
#define IDC_COPYRIGHT_RHG				1015
#define IDC_COPYRIGHT_USA				1016
#define IDC_COPYRIGHT_TENMARU			1017
#define IDC_URL							1018
#define IDC_URL2						1019
#define IDC_URL3						1020
#define IDC_URL4						1021
#define IDC_LPCOPYRIGHT					1039

/* AhX̓_CAO */
#define IDC_ADDRLABEL					1022
#define IDC_ADDRCOMBO					1023

/* l̓_CAO */
#define IDC_MEMLABEL					1024
#define IDC_MEMEDIT						1025

/* WX^l̓_CAO */
#define IDC_REGLABEL					1026
#define IDC_REGEDIT						1027

/* _CAO */
#define IDC_SEARCHDATA					1028
#define IDC_SEARCHADDR					1029

/* ^Cg̓_CAO */
#define IDC_TITLELABEL					1030
#define IDC_TITLEEDIT					1031
#define IDC_TITLEGROUP					1032
#define IDC_TITLE2D						1034
#define IDC_TITLE2DD					1035
#define IDC_TITLEUSRDISK				1036
#define IDC_TITLELABEL2D				1037
#define IDC_TITLEEDIT2D					1038

#if XM7_VER == 1 && defined(BUBBLE)
/* ouϊ^CvI_CAO */
#define IDC_MEDIAFORMATGROUP			1310
#define IDC_MEDIAFORMATB77				1311
#define IDC_MEDIAFORMATBBL				1312
#endif	/* XM7_VER == 1 && defined(BUBBLE) */

/* vpeBy[W */
#define IDC_GP_FM7						1040
#define IDC_GP_FM77AV					1041
#define IDC_GP_FM8						1041
#define IDC_GP_SPEEDMODEG				1042
#define IDC_GP_HIGHSPEED				1043
#define IDC_GP_MIDSPEED					1072
#define IDC_GP_LOWSPEED					1044
#define IDC_GP_SPEEDG					1045
#define IDC_GP_HELP						1046
#define IDC_GP_TAPESPEED				1047
#define IDC_GP_CPUCOMBO					1048
#define IDC_GP_CPUTEXT					1049
#define IDC_GP_CPUSPIN					1050
#define IDC_GP_CPULABEL					1051
#define IDC_GP_MACHINEG					1052
#define IDC_GP_AV40EX					1053
#define IDC_GP_FM77						1053
#define IDC_GP_FULLSPEED				1054
#define IDC_GP_AUTOSPEEDADJUST			1055
#define IDC_GP_FDDWAIT					1056
#define IDC_GP_TAPESPEEDMODE			1057
#define IDC_GP_CPUDEFAULT				1058
#define IDC_GP_CPUSPEEDG				1059
#define IDC_GP_MAIN2MHZ					1060
#define IDC_GP_MAIN1MHZ					1061

/* TEhy[W */
#define IDC_SP_BEEPG					1070
#define IDC_SP_RATEG					1071
#define IDC_SP_96K						1072
#define IDC_SP_88K						1073
#define IDC_SP_51K						1095
#define IDC_SP_48K						1074
#define IDC_SP_44K						1075
#define IDC_SP_25K						1096
#define IDC_SP_22K						1076
#define IDC_SP_NONE						1077
#define IDC_SP_BUFFERG					1078
#define IDC_SP_BUFMS					1079
#define IDC_SP_BUFEDIT					1080
#define IDC_SP_BUFSPIN					1081
#define IDC_SP_BUFTEXT					1082
#define IDC_SP_BEEPEDIT					1083
#define IDC_SP_BEEPTEXT					1084
#define IDC_SP_BEEPHZ					1085
#define IDC_SP_BEEPSPIN					1086
#define IDC_SP_HQMODE					1087
#define IDC_SP_STEREOTEXT				1088
#define IDC_SP_STEREO					1089
#define IDC_SP_TAPEMON					1090
#define IDC_SP_ROMEO					1091
#define IDC_SP_OPTIONG					1092
#define IDC_SP_FDDSOUND					1093
#define IDC_SP_HELP						1094

/* ʒ_CAO */
#define IDC_VP_SEPARATIONG				1100
#define IDC_VP_SEPARATIONCAPTION		1101
#define IDC_VP_SEPARATION				1102
#define IDC_VP_SEPARATIONTEXT			1103
#define IDC_VP_VOLUMEG					1104
#define IDC_VP_FMCAPTION				1105
#define IDC_VP_FMVOLUME					1106
#define IDC_VP_FMVOLUMETEXT				1107
#define IDC_VP_PSGCAPTION				1108
#define IDC_VP_PSGVOLUME				1109
#define IDC_VP_PSGVOLUMETEXT			1110
#define IDC_VP_BEEPCAPTION				1111
#define IDC_VP_BEEPVOLUME				1112
#define IDC_VP_BEEPVOLUMETEXT			1113
#define IDC_VP_CMTCAPTION				1114
#define IDC_VP_CMTVOLUME				1115
#define IDC_VP_CMTVOLUMETEXT			1116
#define IDC_VP_WAVECAPTION				1117
#define IDC_VP_WAVEVOLUME				1118
#define IDC_VP_WAVEVOLUMETEXT			1119
#define IDC_VP_DEFAULT					1120
#define IDC_VP_HELP						1121

/* L[{[hy[W */
#define IDC_KP_MAPG						1130
#define IDC_KP_LIST						1131
#define IDC_KP_101B						1132
#define IDC_KP_106B						1133
#define IDC_KP_98B						1134
#define IDC_KP_USEARROWFOR10			1135
#define IDC_KP_KBDREAL					1136
#define IDC_KP_ARROW8DIR				1137
#define IDC_KP_HELP						1138

/* L[̓_CAO */
#define IDC_KEYIN_LABEL					1140
#define IDC_KEYIN_STATIC				1141
#define IDC_KEYIN_KEY					1142
#define IDC_KEYIN_OK					1143
#define IDC_KEYIN_CANCEL				1144

/* WCXeBbNy[W */
#define IDC_JP_PORTG					1150
#define IDC_JP_PORT1					1151
#define IDC_JP_PORT2					1152
#define IDC_JP_PORTC					IDC_JP_PORT1
#define IDC_JP_TYPEG					1153
#define IDC_JP_TYPEC					1154
#define IDC_JP_RAPIDG					1155
#define IDC_JP_RAPIDA					1156
#define IDC_JP_RAPIDB					1157
#define IDC_JP_RAPIDAC					1158
#define IDC_JP_RAPIDBC					1159
#define IDC_JP_CODEG					1160
#define IDC_JP_UP						1161
#define IDC_JP_UPC						1162
#define IDC_JP_DOWN						1163
#define IDC_JP_DOWNC					1164
#define IDC_JP_LEFT						1165
#define IDC_JP_LEFTC					1166
#define IDC_JP_RIGHT					1167
#define IDC_JP_RIGHTC					1168
#define IDC_JP_CENTER					1169
#define IDC_JP_CENTERC					1170
#define IDC_JP_A						1171
#define IDC_JP_AC						1172
#define IDC_JP_B						1173
#define IDC_JP_BC						1174
#define IDC_JP_HELP						1175

/* XN[y[W */
#define IDC_SCP_MODEG					1180
#define IDC_SCP_MODE					1181
#define IDC_SCP_MODEC					1182
#define IDC_SCP_ETCG					1185
#define IDC_SCP_24K						1186
#define IDC_SCP_24KFS					1187
#define IDC_SCP_CAPTIONB				1188
#define IDC_SCP_TRUECOLOR				1189
#define IDC_SCP_DOUBLESIZE				1190
#define IDC_SCP_RASTERRENDER			1191
#define IDC_SCP_GREENMONITOR			1192
#define IDC_SCP_TTLMONITOR				IDC_SCP_GREENMONITOR
#define IDC_SCP_HELP					1193

/* IvVy[W */
#define IDC_OP_WHGG						1200
#define IDC_OP_WHGB						1201
#define IDC_OP_THGB						1212
#define IDC_OP_DIGITIZEG				1223
#define IDC_OP_DIGITIZEB				1234
#define IDC_OP_RAMG						1245
#define IDC_OP_RAMB						1256
#define	IDC_OP_MOUSEG					1257
#define	IDC_OP_MOUSEEM					1258
#define	IDC_OP_MOUSE_PORT1				1259
#define	IDC_OP_MOUSE_PORT2				1260
#define	IDC_OP_MOUSE_FMMOUSE			1273
#define IDC_OP_OPNB						1261
#define IDC_OP_400LINEG					1262
#define IDC_OP_400LINEB					1263
#define IDC_OP_MOUSESW					1264
#define IDC_OP_MOUSESWC					1265
#define IDC_OP_JSUBG					1266
#define IDC_OP_JSUBB					1267
//		IDC_OP_BANKSELG					1268
//		IDC_OP_BANKSELB					1269
#define IDC_OP_BMCG						1270
#define IDC_OP_BMCB						1271
#define IDC_OP_HELP						1272

/* u[N|Cg_CAO */
#define IDC_BREAKP_ADDRLABEL			1280
#define IDC_BREAKP_ADDRCOMBO			1281
#define IDC_BREAKP_CPUGROUP				1282
#define IDC_BREAKP_CPU_MAIN				1283
#define IDC_BREAKP_CPU_SUB				1284
#define IDC_BREAKP_CPU_JSUB				1285

/* |[gy[W */
#define IDC_POP_MIDIG					1290
#define IDC_POP_MIDIDEV					1291
#define IDC_POP_MIDIDEVC				1292
#define IDC_POP_MIDIDLY					1293
#define IDC_POP_MIDIDLYEDIT				1294
#define IDC_POP_MIDIDLYSPIN				1295
#define IDC_POP_MIDIDLYMS				1296
#define IDC_POP_MIDIDLYSB				1297
#define IDC_POP_COMG					1298
#define IDC_POP_COMPORT					1299
#define IDC_POP_COMPORTC				1300
#define IDC_POP_COMENABLE				1301
#define IDC_POP_COMBPS					1302
#define IDC_POP_COMBPSC					1303
#define IDC_POP_RESETMSG				1304
#define IDC_POP_HELP					1305

/* v^y[W */
#ifdef LPRINT
#define IDC_LPP_LPRG					1310
#define IDC_LPP_LPRENABLE				1311
#define IDC_LPP_LPROSFNT				1312
#define IDC_LPP_LPRKANJI				1313
#define IDC_LPP_HELP					1314
#endif

/* Ȇy[W */
#define IDC_AP_ALTERG					1350
#define IDC_AP_BANKSELB					1351
#define IDC_AP_MAGUSPATCH				1352
#define IDC_AP_OTHERG					1353
#define IDC_AP_POPUPSWND				1354
#define IDC_AP_OFNCENTERING				1355
#define IDC_AP_ROMRAMWRITE				1356

/* t@Cj[ */
#define IDM_OPEN						40001
#define IDM_SAVE						40002
#define IDM_SAVEAS						40003
#define IDM_PRINT						40138
#define IDM_RESET						40004
#define IDM_HOTRESET					40005
#define IDM_BASIC						40006
#define IDM_DOS 						40007
#define IDM_BUBBLE						40008
#define IDM_EXIT						40009

/* hCu1j[ */
#define IDM_D1OPEN						40010
#define IDM_DBOPEN						40011
#define IDM_D1EJECT 					40012
#define IDM_D1TEMP						40013
#define IDM_D1WRITE 					40014
#define IDM_D1MEDIA00					40015
#define IDM_D1MEDIA01					40016
#define IDM_D1MEDIA02					40017
#define IDM_D1MEDIA03					40018
#define IDM_D1MEDIA04					40019
#define IDM_D1MEDIA05					40020
#define IDM_D1MEDIA06					40021
#define IDM_D1MEDIA07					40022
#define IDM_D1MEDIA08					40023
#define IDM_D1MEDIA09					40024
#define IDM_D1MEDIA10					40025
#define IDM_D1MEDIA11					40026
#define IDM_D1MEDIA12					40027
#define IDM_D1MEDIA13					40028
#define IDM_D1MEDIA14					40029
#define IDM_D1MEDIA15					40030

/* hCu0j[ */
#define IDM_D0OPEN						40031
//		IDM_DBOPEN						40032
#define IDM_D0EJECT						40033
#define IDM_D0TEMP						40034
#define IDM_D0WRITE 					40035
#define IDM_D0MEDIA00					40036
#define IDM_D0MEDIA01					40037
#define IDM_D0MEDIA02					40038
#define IDM_D0MEDIA03					40039
#define IDM_D0MEDIA04					40040
#define IDM_D0MEDIA05					40041
#define IDM_D0MEDIA06					40042
#define IDM_D0MEDIA07					40043
#define IDM_D0MEDIA08					40044
#define IDM_D0MEDIA09					40045
#define IDM_D0MEDIA10					40046
#define IDM_D0MEDIA11					40047
#define IDM_D0MEDIA12					40048
#define IDM_D0MEDIA13					40049
#define IDM_D0MEDIA14					40050
#define IDM_D0MEDIA15					40051

/* e[vj[ */
#define IDM_TOPEN						40052
#define IDM_TEJECT						40053
#define IDM_REW							40054
#define IDM_FF							40055
#define IDM_REC							40056

/* ouz_0j[ */
#define IDM_B0OPEN						40057
#define IDM_BBOPEN						40516
#define IDM_B0EJECT						40058
#define IDM_B0TEMP						40059
#define IDM_B0WRITE						40060
#define IDM_B0MEDIA00					40500
#define IDM_B0MEDIA01					40501
#define IDM_B0MEDIA02					40502
#define IDM_B0MEDIA03					40503
#define IDM_B0MEDIA04					40504
#define IDM_B0MEDIA05					40505
#define IDM_B0MEDIA06					40506
#define IDM_B0MEDIA07					40507
#define IDM_B0MEDIA08					40508
#define IDM_B0MEDIA09					40509
#define IDM_B0MEDIA10					40510
#define IDM_B0MEDIA11					40511
#define IDM_B0MEDIA12					40512
#define IDM_B0MEDIA13					40513
#define IDM_B0MEDIA14					40514
#define IDM_B0MEDIA15					40515

/* ouz_1j[ */
#define IDM_B1OPEN						40061
//efine IDM_BBOPEN						40516
#define IDM_B1EJECT						40062
#define IDM_B1TEMP						40063
#define IDM_B1WRITE						40064
#define IDM_B1MEDIA00					40520
#define IDM_B1MEDIA01					40521
#define IDM_B1MEDIA02					40522
#define IDM_B1MEDIA03					40523
#define IDM_B1MEDIA04					40524
#define IDM_B1MEDIA05					40525
#define IDM_B1MEDIA06					40526
#define IDM_B1MEDIA07					40527
#define IDM_B1MEDIA08					40528
#define IDM_B1MEDIA09					40529
#define IDM_B1MEDIA10					40530
#define IDM_B1MEDIA11					40531
#define IDM_B1MEDIA12					40532
#define IDM_B1MEDIA13					40533
#define IDM_B1MEDIA14					40534
#define IDM_B1MEDIA15					40535

/* \j[ */
#define IDM_FDC							40065
#define IDM_BMC							40066
#define IDM_OPNREG						40067
#define IDM_OPNDISP						40068
#define IDM_SUBCTRL						40069
#define IDM_KEYBOARD					40070
#define IDM_MMR							40071
#define IDM_DMAC						40072
#define IDM_ALULINE						40073
#define IDM_CYCLESTEAL					40074
#define IDM_STATUS						40075
#define IDM_REFRESH						40076
#define IDM_SYNC						40077
#define IDM_FULLSCREEN					40078
#define IDM_PALETTE						40079

/* fobOj[ */
#define IDM_EXEC 						40080
#define IDM_BREAK						40081
#define IDM_TRACE						40082
#define IDM_BREAKPOINT					40083
#define IDM_SCHEDULER					40084
#define IDM_CPU_MAIN					40085
#define IDM_CPU_SUB						40086
#define IDM_DISASM_MAIN					40087
#define IDM_DISASM_SUB					40088
#define IDM_MEMORY_MAIN					40089
#define IDM_MEMORY_SUB					40090
#define IDM_CPU_JSUB					40091
#define IDM_DISASM_JSUB					40092
#define IDM_MEMORY_JSUB					40093

/* c[j[ */
#define IDM_CONFIG						40094
#define IDM_GRPCAP						40095
#define IDM_WAVCAP						40096
#define IDM_NEWDISK						40097
#define IDM_NEWTAPE						40098
#define IDM_NEWBUBBLE					40099
#define IDM_VFD2D77						40100
#define IDM_2D2D77						40101
#define IDM_VTP2T77						40102
#define IDM_GRPCAP2						40103
#define IDM_TIMEADJUST					40104
#define IDM_MOUSEMODE					40105
#define IDM_BBL2B77						40106
#define IDM_MOUSEMODE2					40107
#define IDM_MOUSEON						40108
#define IDM_MOUSEOFF					40109
#define IDM_S98CAP						40138

/* EBhEj[ */
#define IDM_CASCADE						40110
#define IDM_TILE						40111
#define IDM_ICONIC						40112
#define IDM_ARRANGEICON					40113
#define IDM_ALLHIDE						40114
#define IDM_ALLRESTORE					40115
#define IDM_ALLCLOSE					40137
#define IDM_SWND00						40116
#define IDM_SWND01						40117
#define IDM_SWND02						40118
#define IDM_SWND03						40119
#define IDM_SWND04						40120
#define IDM_SWND05						40121
#define IDM_SWND06						40122
#define IDM_SWND07						40123
#define IDM_SWND08						40124
#define IDM_SWND09						40125
#define IDM_SWND10						40126
#define IDM_SWND11						40127
#define IDM_SWND12						40128
#define IDM_SWND13						40129
#define IDM_SWND14						40130
#define IDM_SWND15						40131
#define IDM_SWND16						40132
#define IDM_SWND17						40133
#define IDM_SWND18						40134
#define IDM_SWND19						40135

/* wvj[ */
#define IDM_ABOUT						40136

/* ReLXgj[(tAZu) */
#define IDM_DIS_ADDR					40200
#define IDM_DIS_PC						40201
#define IDM_DIS_X						40202
#define IDM_DIS_Y						40203
#define IDM_DIS_U						40204
#define IDM_DIS_S						40205
#define IDM_DIS_RESET					40206
#define IDM_DIS_NMI						40207
#define IDM_DIS_SWI						40208
#define IDM_DIS_IRQ						40209
#define IDM_DIS_FIRQ					40210
#define IDM_DIS_SWI2					40211
#define IDM_DIS_SWI3					40212
#define IDM_DIS_JUMP					40213
#define IDM_DIS_SYNCPC					40214
#define	IDM_DIS_STACK					40216
#define	IDM_DIS_BREAK					40232
#define IDM_DIS_PHYSADDR				40217

/* ReLXgj[(_v) */
#define IDM_DMP_ADDR					40250
#define IDM_DMP_PC						40251
#define IDM_DMP_X						40252
#define IDM_DMP_Y						40253
#define IDM_DMP_U						40254
#define IDM_DMP_S						40255
#define IDM_DMP_RESET					40256
#define IDM_DMP_NMI						40257
#define IDM_DMP_SWI						40258
#define IDM_DMP_IRQ						40259
#define IDM_DMP_FIRQ					40260
#define IDM_DMP_SWI2					40261
#define IDM_DMP_SWI3					40262
#define IDM_DMP_DP						40263
#define IDM_DMP_IO						40264
#define IDM_DMP_BLK128					40265
#define IDM_DMP_BLK256					40266
#define IDM_DMP_ASCII					40267
#define IDM_DMP_KANJI					40268
#define IDM_DMP_SEARCH					40269
#define	IDM_DMP_STACK					40270
#define IDM_DMP_PHYSADDR				40310
#define IDM_DMP_00000					40311
#define IDM_DMP_10000					40312
#define IDM_DMP_20000					40313
#define IDM_DMP_30000					40314
#define IDM_DMP_40000					40315
#define IDM_DMP_50000					40316
#define IDM_DMP_60000					40317
#define IDM_DMP_70000					40318
#define IDM_DMP_80000					40319
#define IDM_DMP_90000					40320
#define IDM_DMP_A0000					40321
#define IDM_DMP_B0000					40322
#define IDM_DMP_C0000					40323
#define IDM_DMP_D0000					40324
#define IDM_DMP_E0000					40325
#define IDM_DMP_F0000					40326

/* ReLXgj[(u[N|Cg) */
#define IDM_BREAKP_JUMP					40300
#define IDM_BREAKP_ENABLE 				40301
#define IDM_BREAKP_DISABLE				40302
#define IDM_BREAKP_CLEAR				40303
#define IDM_BREAKP_ALL					40304
#define IDM_BREAKP_SET					40305

/* ReLXgj[(CPUWX^) */
#define IDM_REG_CC						40350
#define IDM_REG_A						40351
#define IDM_REG_B						40352
#define IDM_REG_DP						40353
#define IDM_REG_D						40354
#define IDM_REG_X						40355
#define IDM_REG_Y						40356
#define IDM_REG_U						40357
#define IDM_REG_S						40358
#define IDM_REG_PC						40359

/* L[{[hV[gJbg */
#define	IDM_CHG_SOUNDMODE				40400

/* bZ[WQ */
#define IDS_IDLEMESSAGE 				41000
#define IDS_VMERROR 					41001
#define IDS_DXERROR						41002
#define IDS_RUNCAPTION					41003
#define IDS_STOPCAPTION					41004
#define IDS_DISKFILTER					41005
#define IDS_DISKOPEN					41006
#define IDS_DISKBOTH					41007
#define IDS_DISKEJECT					41008
#define IDS_DISKPROTECT					41009
#define IDS_DISK2D						41010
#define IDS_TAPEFILTER					41011
#define IDS_TAPEOPEN					41012
#define IDS_TAPEEJECT					41013
#define IDS_TAPEREW						41014
#define IDS_TAPEFF						41015
#define IDS_TAPEREC						41016
#define IDS_NEWTAPEOK					41017
#define IDS_NEWDISKFILTER				41018
#define IDS_NEWDISKOK					41019
#define IDS_BUBBLEFILTER				41020
#define IDS_BUBBLE0						41021
#define IDS_BUBBLE1						41022
#define IDS_BUBBLEOPEN					41023
#define IDS_BUBBLEEJECT					41024
#define IDS_BUBBLETEMP					41025
#define IDS_BUBBLEPROTECT				41026
#define IDS_NEWBUBBLEOK					41027
#define IDS_GRPCAPFILTER				41028
#define IDS_SWND_CPUREG_MAIN			41029
#define IDS_SWND_CPUREG_SUB				41030
#define IDS_SWND_SCHEDULER				41031
#define IDS_SWND_DISASM_MAIN			41032
#define IDS_SWND_DISASM_SUB				41033
#define IDS_SWND_MEMORY_MAIN			41034
#define IDS_SWND_MEMORY_SUB				41035
#define IDS_SWND_BMC					41036
#define IDS_STATEFILTER					41037
#define IDS_STATEERROR					41038
#define IDS_SWND_BREAKPOINT				41039
#define IDS_SWND_FDC					41040
#define IDS_VFDFILTER					41041
#define IDS_2DFILTER					41042
#define IDS_VTPFILTER					41043
#define IDS_CONVERTOK					41044
#define IDS_CONVERTFAIL					41141
#define IDS_SWND_OPNREG					41045
#define IDS_SWND_SUBCTRL				41046
#define IDS_CONFIGCAPTION				41047
#define IDS_GP_MAINCPU					41048
#define IDS_GP_MAINMMR					41049
#define IDS_SWND_OPNDISP				41050
#define IDS_SWND_KEYBOARD				41051
#define IDS_KP_KEYNO					41052
#define IDS_KP_KEYFM					41053
#define IDS_KP_KEYKANA					41054
#define IDS_KP_KEYDI					41055
#define IDS_DISKTEMP					41056
#define IDS_JP_RAPID0					41057
#define IDS_JP_RAPID1					41058
#define IDS_JP_RAPID2					41059
#define IDS_JP_RAPID3					41060
#define IDS_JP_RAPID4					41061
#define IDS_JP_RAPID5					41062
#define IDS_JP_RAPID6					41063
#define IDS_JP_RAPID7					41064
#define IDS_JP_RAPID8					41065
#define IDS_JP_RAPID9					41066
#define IDS_JP_TYPE0					41067
#define IDS_JP_TYPE1					41068
#define IDS_JP_TYPE2					41069
#define IDS_JP_TYPE3					41070
#define IDS_JP_TYPE4					41071
#define IDS_ABOUTURL_OLD				41072
#define IDS_SWND_MMR					41073
#define IDS_WAVCAPFILTER				41074
#define IDS_WAVCAPERROR					41075
#define IDS_GP_SUBCPU					41076
#define IDS_SP_MONO						41077
#define IDS_SP_STEREO					41078
#define IDS_SP_STEREO_REV				41079
#define IDS_SP_STEREO_THG				41080
#define IDS_DISKVFD						41081
#define IDS_SWND_DMAC					41082
#define IDS_GP_FASTMMR					41083
#define IDS_GP_JSUBCPU					41083
#define IDS_SWND_ALULINE				41084
#define IDS_MEDIA_CHANGE				41085
#define IDS_DISK2DD						41086
#define IDS_SND_MONAURAL				41087
#define IDS_SND_WHG_NORMAL				41088
#define IDS_SND_WHG_REVERSE				41089
#define IDS_SND_THG_NORMAL				41090
#define IDS_MOUSE_DISABLE				41091
#define IDS_MOUSE_ENABLE				41092
#define IDS_MOUSEMODE_ENBF11			41093
#define IDS_MOUSEMODE_DISF11			41094
#define IDS_COMM_OPENERROR				41095
#define IDS_COMM_THREADERROR			41096
#define IDS_MEDIA_NAME					41097
#define IDS_COINITERROR					41098
#define IDS_SWND_CPU_MAIN				41099
#define IDS_SWND_CPU_SUB				41100
#define IDS_SWND_CPU_MAIN_P				41139
#define IDS_SWND_SRCH_FOUND				41101
#define IDS_SWND_SRCH_FOUND_P			41140
#define IDS_SWND_SRCH_NOTFOUND			41102
#define IDS_SWND_CPU_JSUB				41103
#define IDS_SWND_CPUREG_JSUB			41104
#define IDS_SWND_DISASM_JSUB			41105
#define IDS_SWND_MEMORY_JSUB			41106
#define IDS_SWND_BREAKPOINT_NONE		41122
#define IDS_JP_NOASSIGN					41107
#define IDS_GP_MAINCPU_LOW				41108
#define IDS_GP_SUBCPU_LOW				41109
#define IDS_GP_MAINCPU_Z80				41110
#define IDS_OP_MOUSESW_1				41112
#define IDS_OP_MOUSESW_2				41113
#define IDS_OP_MOUSESW_3				41114
#define IDS_SWND_PSGREG					41115
#define IDS_SWND_PSGDISP				41116
#define IDS_BAR_CAP						41117
#define IDS_BAR_KANA					41118
#define IDS_BAR_INS						41119
#define IDS_ENABLE_CYCLESTEAL			41120
#define IDS_DISABLE_CYCLESTEAL			41121
#define IDS_POP_NONE					IDS_SWND_BREAKPOINT_NONE
#define	IDS_POP_COM300					41123
#define	IDS_POP_COM600					41124
#define	IDS_POP_COM1200					41125
#define	IDS_POP_COM2400					41126
#define	IDS_POP_COM4800					41127
#define	IDS_SCP_400LINE					41128
#define	IDS_SCP_480LINE					41129
#define	IDS_SCP_WUXGA					41130
#define	IDS_SCP_SXGA					41131
#define	IDS_SCP_WXGA					41132
#define IDS_SWND_REG_MESSAGE			41133
#define	IDS_BBOPEN						41134
#define	IDS_B77FILTER					41135
#define	IDS_BBLFILTER					41136
#define	IDS_BBLFILE						41137
#define IDS_SWND_PALETTE				41138
#define IDS_ABOUTURL					41200
#define IDS_ABOUTURL2					41201
#define IDS_ABOUTURL3					41202
#define IDS_ABOUTURL4					41203

#endif	/* _WIN32 */
